Subject: Re: bug#18336: 24.4.50; When editing externally changed file, Emacs asks too many questions

From: Noam Postavsky <[email-masked]>
Date: Sun, 22 Mar 2020 11:45:24 -0400

Eli Zaretskii <[email-masked]> writes:

>> From: Noam Postavsky <[email-masked]>
>> Cc: [email-masked],  [email-masked],  [email-masked]
>> Date: Sat, 21 Mar 2020 21:13:59 -0400
>> 
>> >> Why exactly are we calling lock_file from write_region?
>> >
>> > Because write-region can be called from an unmodified buffer, I
>> > suppose, and from a buffer whose buffer-file-name is not the same as
>> > the file being written to.
>> 
>> So maybe we could just check those conditions?  Here's a patch,
>> tentatively suggested for master.
>
> Isn't it better to check whether the file is already locked?  That
> way, we don't need any (error-prone) heuristics for when it's okay to
> ask the question and when it isn't.

If I understand the code correctly, lock_file() already checks this (the
'&& !NILP (Ffile_exists_p (fn))' part), but takes the wrong action in
that case.  So I'm not sure what we should do differently.